#
# This is the SPEC file for creating binary RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <https://www.gnu.org/licenses/>.
#
#

Name:		qubes-core-qrexec
Version:	4.1.22
Release:	1%{dist}
Summary:	The Qubes qrexec files (common files)

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

BuildRequires:	gcc
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:	python%{python3_pkgversion}-dbus
# for building documentation
BuildRequires:	python%{python3_pkgversion}-sphinx
BuildRequires:	python%{python3_pkgversion}-recommonmark
BuildRequires:	qubes-libvchan-devel
BuildRequires:  python%{python3_pkgversion}-rpm-macros

Requires:   python%{python3_pkgversion}
Requires:   python%{python3_pkgversion}-gbulb
Conflicts:  qubes-utils-libs < 4.1.0
Conflicts:  qubes-core-agent-qrexec < 4.1.0
Conflicts:  qubes-core-dom0 < 4.1.10
Conflicts:  qubes-core-dom0-linux < 4.1.5
Conflicts:  qubes-gui-agent < 4.1.6
Conflicts:  qubes-gpg-split < 2.0.45
Conflicts:  qubes-gui-daemon < 4.1.4
Conflicts:  qubes-input-proxy < 1.0.17
Conflicts:  qubes-pdf-converter < 2.1.7
Conflicts:  qubes-usb-proxy < 1.0.28

Source0: qubes-core-qrexec-%{version}.tar.gz

%description
The Qubes qrexec files for installation on both dom0 and qube.

%package libs
Summary:    Libraries for qubes-qrexec
Conflicts:  qubes-utils-libs < 4.1.0

%description libs
Libraries for qubes-qrexec

%package devel
Summary:    Development headers for qubes-qrexec
Requires:   %{name}-libs

%description devel
Development header and files for qubes-qrexec

%prep
%setup -qn qubes-core-qrexec-%{version}

%build
%{?set_build_flags}
make all-base PYTHON=%{__python3}
make -C doc PYTHON=python3 SPHINXBUILD=sphinx-build-3 man

%install
make install-base \
    INCLUDEDIR=%{_includedir} \
    LIBDIR=%{_libdir} \
    SYSCONFDIR=%{_sysconfdir} \
    UNITDIR=%{_unitdir} \
    PYTHON_SITEPATH=%{python3_sitelib} \
    PYTHON=%{__python3} \
    DESTDIR=$RPM_BUILD_ROOT

make -C doc \
    DESTDIR=$RPM_BUILD_ROOT \
    SPHINXBUILD=sphinx-build-3 \
    install

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%files
%defattr(-,root,root,-)

%{_bindir}/qrexec-policy-exec
%{_bindir}/qrexec-policy-agent
%{_bindir}/qrexec-policy-graph
%{_bindir}/qrexec-policy-restore
%{_bindir}/qrexec-policy-daemon
%{_bindir}/qubes-policy
%{_bindir}/qubes-policy-admin
%{_bindir}/qrexec-policy

/usr/lib/qubes/qubes-rpc-multiplexer
/usr/lib/qubes/qrexec-policy-agent-autostart

%{_sysconfdir}/qubes-rpc/policy.Ask
%{_sysconfdir}/qubes-rpc/policy.Notify

%{_sysconfdir}/xdg/autostart/qrexec-policy-agent.desktop

%dir %{python3_sitelib}/qrexec-*.egg-info
%{python3_sitelib}/qrexec-*.egg-info/*

%dir %{python3_sitelib}/qrexec
%dir %{python3_sitelib}/qrexec/__pycache__
%{python3_sitelib}/qrexec/__pycache__/*
%{python3_sitelib}/qrexec/__init__.py
%{python3_sitelib}/qrexec/client.py
%{python3_sitelib}/qrexec/exc.py
%{python3_sitelib}/qrexec/utils.py
%{python3_sitelib}/qrexec/server.py

%dir %{python3_sitelib}/qrexec/policy
%dir %{python3_sitelib}/qrexec/policy/__pycache__
%{python3_sitelib}/qrexec/policy/__pycache__/*
%{python3_sitelib}/qrexec/policy/__init__.py
%{python3_sitelib}/qrexec/policy/admin.py
%{python3_sitelib}/qrexec/policy/admin_client.py
%{python3_sitelib}/qrexec/policy/parser.py
%{python3_sitelib}/qrexec/policy/parser_compat.py
%{python3_sitelib}/qrexec/policy/utils.py

%dir %{python3_sitelib}/qrexec/tools
%dir %{python3_sitelib}/qrexec/tools/__pycache__
%{python3_sitelib}/qrexec/tools/__pycache__/*
%{python3_sitelib}/qrexec/tools/__init__.py
%{python3_sitelib}/qrexec/tools/qubes_policy.py
%{python3_sitelib}/qrexec/tools/qubes_policy_admin.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_agent.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_exec.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_daemon.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_graph.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_restore.py

%dir %{python3_sitelib}/qrexec/tests
%dir %{python3_sitelib}/qrexec/tests/__pycache__
%{python3_sitelib}/qrexec/tests/__pycache__/*
%{python3_sitelib}/qrexec/tests/__init__.py
%{python3_sitelib}/qrexec/tests/cli.py
%{python3_sitelib}/qrexec/tests/gtkhelpers.py
%{python3_sitelib}/qrexec/tests/rpcconfirmation.py
%{python3_sitelib}/qrexec/tests/policy_parser.py
%{python3_sitelib}/qrexec/tests/qrexec_policy_daemon.py
%{python3_sitelib}/qrexec/tests/policy_cache.py
%{python3_sitelib}/qrexec/tests/server.py
%{python3_sitelib}/qrexec/tests/policy_admin.py

%dir %{python3_sitelib}/qrexec/tests/socket
%dir %{python3_sitelib}/qrexec/tests/socket/__pycache__
%{python3_sitelib}/qrexec/tests/socket/__pycache__/*
%{python3_sitelib}/qrexec/tests/socket/__init__.py
%{python3_sitelib}/qrexec/tests/socket/agent.py
%{python3_sitelib}/qrexec/tests/socket/daemon.py
%{python3_sitelib}/qrexec/tests/socket/qrexec.py
%{python3_sitelib}/qrexec/tests/socket/util.py

%dir %{python3_sitelib}/qrexec/glade
%{python3_sitelib}/qrexec/glade/RPCConfirmationWindow.glade

%{_datadir}/man/man1/qubes-core-qrexec.1.gz

%files devel
%{_includedir}/qrexec.h
%{_includedir}/libqrexec-utils.h

%files libs
%{_libdir}/libqrexec-utils.so*

%changelog
* Tue May 23 2023 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-core-qrexec.git

* Tue May 23 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 99eaa5c
- version 4.1.22

* Mon May 22 2023 Ben Grande <ben.grande.b@gmail.com> - ba12e34
- Fix missing include in RPC names in admin_client

* Mon May 22 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f0b1904
- Revert "Fix some mypy errors"

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 9439779
- Use pytest_asyncio.fixture() for async test fixtures

* Fri May 12 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 691ae45
- Do not use 'annotation' future extension (R4.1)

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 3e61902
- avoid option injection in 'make clean'

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - f503643
- Clean up gcov cruft in 'make clean'

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - a0535aa
- Fix make install when already installed

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - c97b0d7
- Fix some mypy errors

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - c6dad2f
- Forcibly rebuild C code for socket tests

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 57ce55f
- Avoid option injection for usernames starting with "-"

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - ff36122
- Add missing static

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 7a3aa3f
- Add a missing #include

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - aaf1454
- More consistency checks in buffer code

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 297e098
- Correctly detect SOCK_CLOEXEC

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 558ade2
- Slightly better validation of data from dom0

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - c5ab6cb
- Fix reserved identifier violations

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b6a5c65
- Avoid K&R function declarations

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 5f580e0
- Ensure all data is sent to policy daemon

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 577a207
- Ignore stopped or continued children

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 9efe28b
- Fix signal handling bugs

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 61baaa6
- Check return value of snprintf()

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 5f57019
- Check the return value of strdup()

* Fri May 12 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c066679
- Make pylint happy

* Fri May 12 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6443f45
- Do not call asyncio.get_event_loop() before creating one

* Fri May 12 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7447e2c
- Wrap coroutine in a task before passing to asyncio.wait

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - e63e87f
- Remove the connect_existing variable

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 30e4629
- qrexec-client-vm: add --help

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - ef3b45d
- More error checking

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 490130c
- Add some error checking

* Fri May 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 90667fc
- Zero-initialize some stack variables

* Thu May 11 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 77d5c13
- version 4.1.21

* Thu May 11 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7d9fddf
- daemon: fix off-by-one in MSG_TRIGGER_SERVICE3 validation

* Tue Nov 29 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 129159e
- version 4.1.20

* Tue Nov 29 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 39ce868
- Relax validation of MSG_DATA_STDIN/MSG_DATA_STDOUT

* Tue Nov 29 2022 Marta Marczykowska-Górecka <marta.maria.gorecka@gmail.com> - 6c2d9e7
- Fix incorrect ownership of policy dirs

* Tue Nov 29 2022 Marta Marczykowska-Górecka <marta.maria.gorecka@gmail.com> - ac9f104
- Remove root user requirement for policy admin client

* Tue Nov 29 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3b65322
- Reformat code to be PEP8 compliant

* Tue Nov 29 2022 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 9ba2596
- Drop Travis CI

* Wed Nov 23 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7dc10e6
- version 4.1.19

* Wed Nov 23 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 24ee2bb
- Update fuzzer wrapper

* Wed Nov 23 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d6cf068
- Ignore oversensitive pylint warnings

* Wed Nov 23 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e47575e
- ci: install extra packages necessary for unit tests

* Wed Nov 23 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 3d02188
- Prevent log injection into qrexec-agent

* Sat Mar 05 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 75e794e
- version 4.1.18

* Wed Mar 02 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 92a1734
- Fix parsing legacy policy files

* Fri Feb 18 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7f910aa
- version 4.1.17

* Tue Feb 15 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6c78dc3
- policy: fix notification on refused autostart

* Fri Jan 14 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c8e83f9
- Fix error return value in allocate_vchan_port

* Fri Dec 17 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ebdc43b
- version 4.1.16

